diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/csma/model/csma-net-device.h ns-3.47/src/csma/model/csma-net-device.h
--- ns-3.46/src/csma/model/csma-net-device.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/csma/model/csma-net-device.h	2026-02-16 16:08:49.593229800 -0800
@@ -80,6 +80,10 @@
      */
     ~CsmaNetDevice() override;
 
+    // Delete copy constructor and assignment operator to avoid misuse
+    CsmaNetDevice(const CsmaNetDevice&) = delete;
+    CsmaNetDevice& operator=(const CsmaNetDevice&) = delete;
+
     /**
      * Set the interframe gap used to separate packets.  The interframe gap
      * defines the minimum space required between packets sent by this device.
@@ -353,21 +357,6 @@
 
   private:
     /**
-     * Operator = is declared but not implemented.  This disables the assignment
-     * operator for CsmaNetDevice objects.
-     * @param o object to copy
-     * @returns the copied object
-     */
-    CsmaNetDevice& operator=(const CsmaNetDevice& o);
-
-    /**
-     * Copy constructor is declared but not implemented.  This disables the
-     * copy constructor for CsmaNetDevice objects.
-     * @param o object to copy
-     */
-    CsmaNetDevice(const CsmaNetDevice& o);
-
-    /**
      * Initialization function used during object construction.
      * @param sendEnable if device will be allowed to send
      * @param receiveEnable if device will be allowed to receive
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/csma-layout/examples/csma-star.cc ns-3.47/src/csma-layout/examples/csma-star.cc
--- ns-3.46/src/csma-layout/examples/csma-star.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/csma-layout/examples/csma-star.cc	2026-02-16 16:08:49.592229800 -0800
@@ -49,8 +49,8 @@
     //
     uint32_t nSpokes = 7;
     uint32_t useIpv6 = 0;
-    Ipv6Address ipv6AddressBase = Ipv6Address("2001::");
-    Ipv6Prefix ipv6AddressPrefix = Ipv6Prefix(64);
+    auto ipv6AddressBase = Ipv6Address("2001::");
+    auto ipv6AddressPrefix = Ipv6Prefix(64);
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("nSpokes", "Number of spoke nodes to place in the star", nSpokes);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/dsr/model/dsr-fs-header.h ns-3.47/src/dsr/model/dsr-fs-header.h
--- ns-3.46/src/dsr/model/dsr-fs-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/dsr/model/dsr-fs-header.h	2026-02-16 16:08:49.595229900 -0800
@@ -308,6 +308,12 @@
     uint32_t Deserialize(Buffer::Iterator start) override;
 };
 
+/**
+ * @brief Output streamer for DsrRoutingHeader
+ * @param os The output stream
+ * @param dsr The DsrRoutingHeader
+ * @return The stream
+ */
 static inline std::ostream&
 operator<<(std::ostream& os, const DsrRoutingHeader& dsr)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/dsr/model/dsr-network-queue.h ns-3.47/src/dsr/model/dsr-network-queue.h
--- ns-3.46/src/dsr/model/dsr-network-queue.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/dsr/model/dsr-network-queue.h	2026-02-16 16:08:49.595229900 -0800
@@ -33,6 +33,7 @@
 namespace dsr
 {
 
+/** Flag used to prioritize packets */
 enum DsrMessageType
 {
     DSR_CONTROL_PACKET = 1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/dsr/model/dsr-option-header.h ns-3.47/src/dsr/model/dsr-option-header.h
--- ns-3.46/src/dsr/model/dsr-option-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/dsr/model/dsr-option-header.h	2026-02-16 16:08:49.595229900 -0800
@@ -1281,10 +1281,16 @@
     Ipv4Address m_realDstAddress;
 };
 
+/**
+ * @brief Output streamer for DsrOptionSRHeader
+ * @param os The output stream
+ * @param dsr The DsrOptionSRHeader
+ * @return The stream
+ */
 [[maybe_unused]] static inline std::ostream&
-operator<<(std::ostream& os, const DsrOptionSRHeader& sr)
+operator<<(std::ostream& os, const DsrOptionSRHeader& dsr)
 {
-    sr.Print(os);
+    dsr.Print(os);
     return os;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/dsr/model/dsr-rcache.cc ns-3.47/src/dsr/model/dsr-rcache.cc
--- ns-3.46/src/dsr/model/dsr-rcache.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/dsr/model/dsr-rcache.cc	2026-02-16 16:08:49.596229800 -0800
@@ -46,6 +46,14 @@
 namespace dsr
 {
 
+/**
+ * @ingroup dsr
+ * @brief Compare route cache entries by hop count and priority,
+ *        equivalent to comparing the expire time.
+ * @param a The first route cache entry
+ * @param b The second route canche entry
+ * @returns `true` if `a < b`
+ */
 bool
 CompareRoutesBoth(const DsrRouteCacheEntry& a, const DsrRouteCacheEntry& b)
 {
@@ -55,6 +63,13 @@
             (a.GetExpireTime() > b.GetExpireTime()));
 }
 
+/**
+ * @ingroup dsr
+ * @brief Compare route cache entries by hop count only
+ * @param a The first route cache entry
+ * @param b The second route canche entry
+ * @returns `true` if `a < b`
+ */
 bool
 CompareRoutesHops(const DsrRouteCacheEntry& a, const DsrRouteCacheEntry& b)
 {
@@ -62,6 +77,13 @@
     return a.GetVector().size() < b.GetVector().size();
 }
 
+/**
+ * @ingroup dsr
+ * @brief Compare route cache entries by hop priority only.
+ * @param a The first route cache entry
+ * @param b The second route canche entry
+ * @returns `true` if `a < b`
+ */
 bool
 CompareRoutesExpire(const DsrRouteCacheEntry& a, const DsrRouteCacheEntry& b)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/helper/energy-harvester-container.h ns-3.47/src/energy/helper/energy-harvester-container.h
--- ns-3.46/src/energy/helper/energy-harvester-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/helper/energy-harvester-container.h	2026-02-16 16:08:49.598230000 -0800
@@ -94,11 +94,10 @@
      * for-loop to run through the EnergyHarvesters.
      *
      * @code
-     *   EnergyHarvesterContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some EnergyHarvester method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some EnergyHarvester method
+     *   }
      * @endcode
      */
     Iterator Begin() const;
@@ -115,11 +114,10 @@
      * for-loop to run through the EnergyHarvesters.
      *
      * @code
-     *   EnergyHarvesterContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some EnergyHarvester method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some EnergyHarvester method
+     *   }
      * @endcode
      */
     Iterator End() const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/helper/energy-source-container.h ns-3.47/src/energy/helper/energy-source-container.h
--- ns-3.46/src/energy/helper/energy-source-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/helper/energy-source-container.h	2026-02-16 16:08:49.598230000 -0800
@@ -92,11 +92,10 @@
      * for-loop to run through the EnergySources.
      *
      * @code
-     *   EnergySourceContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some EnergySource method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some EnergySource method
+     *   }
      * @endcode
      */
     Iterator Begin() const;
@@ -113,11 +112,10 @@
      * for-loop to run through the EnergySources.
      *
      * @code
-     *   EnergySourceContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some EnergySource method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some EnergySource method
+     *   }
      * @endcode
      */
     Iterator End() const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/model/basic-energy-harvester.cc ns-3.47/src/energy/model/basic-energy-harvester.cc
--- ns-3.46/src/energy/model/basic-energy-harvester.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/model/basic-energy-harvester.cc	2026-02-16 16:08:49.598230000 -0800
@@ -9,6 +9,8 @@
 
 #include "basic-energy-harvester.h"
 
+#include "energy-source.h"
+
 #include "ns3/assert.h"
 #include "ns3/log.h"
 #include "ns3/pointer.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/model/device-energy-model-container.h ns-3.47/src/energy/model/device-energy-model-container.h
--- ns-3.46/src/energy/model/device-energy-model-container.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/model/device-energy-model-container.h	2026-02-16 16:08:49.599229800 -0800
@@ -87,11 +87,10 @@
      * for-loop to run through the DeviceEnergyModels.
      *
      * @code
-     *   DeviceEnergyModelContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some DeviceEnergyModel method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some DeviceEnergyModel method
+     *   }
      * @endcode
      */
     Iterator Begin() const;
@@ -108,11 +107,10 @@
      * for-loop to run through the DeviceEnergyModels.
      *
      * @code
-     *   DeviceEnergyModelContainer::Iterator i;
-     *   for (i = container.Begin (); i != container.End (); ++i)
-     *     {
-     *       (*i)->method ();  // some DeviceEnergyModel method
-     *     }
+     *   for (auto i = container.Begin(); i != container.End(); ++i)
+     *   {
+     *       (*i)->method(); // some DeviceEnergyModel method
+     *   }
      * @endcode
      */
     Iterator End() const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/model/energy-harvester.cc ns-3.47/src/energy/model/energy-harvester.cc
--- ns-3.46/src/energy/model/energy-harvester.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/model/energy-harvester.cc	2026-02-16 16:08:49.599229800 -0800
@@ -9,7 +9,10 @@
 
 #include "energy-harvester.h"
 
+#include "energy-source.h"
+
 #include "ns3/log.h"
+#include "ns3/node.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/model/energy-harvester.h ns-3.47/src/energy/model/energy-harvester.h
--- ns-3.46/src/energy/model/energy-harvester.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/model/energy-harvester.h	2026-02-16 16:08:49.599229800 -0800
@@ -10,17 +10,17 @@
 #ifndef ENERGY_HARVESTER_H
 #define ENERGY_HARVESTER_H
 
-#include <iostream>
-
-// include from ns-3
-#include "ns3/energy-source-container.h"
-#include "ns3/node.h"
 #include "ns3/object.h"
 #include "ns3/ptr.h"
 #include "ns3/type-id.h"
 
+#include <iostream>
+
 namespace ns3
 {
+
+class Node;
+
 namespace energy
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/model/energy-source.cc ns-3.47/src/energy/model/energy-source.cc
--- ns-3.46/src/energy/model/energy-source.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/model/energy-source.cc	2026-02-16 16:08:49.599229800 -0800
@@ -70,8 +70,7 @@
 {
     NS_LOG_FUNCTION(this << tid);
     DeviceEnergyModelContainer container;
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         if ((*i)->GetInstanceTypeId() == tid)
         {
@@ -86,8 +85,7 @@
 {
     NS_LOG_FUNCTION(this << name);
     DeviceEnergyModelContainer container;
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         if ((*i)->GetInstanceTypeId().GetName() == name)
         {
@@ -105,8 +103,7 @@
      * Device models are not aggregated to the node, hence we have to manually
      * call dispose method here.
      */
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         (*i)->Initialize();
     }
@@ -120,8 +117,7 @@
      * Device models are not aggregated to the node, hence we have to manually
      * call dispose method here.
      */
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         (*i)->Dispose();
     }
@@ -155,8 +151,7 @@
 {
     NS_LOG_FUNCTION(this);
     double totalCurrentA = 0.0;
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         totalCurrentA += (*i)->GetCurrentA();
     }
@@ -190,8 +185,7 @@
 {
     NS_LOG_FUNCTION(this);
     // notify all device energy models installed on node
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         (*i)->HandleEnergyDepletion();
     }
@@ -202,8 +196,7 @@
 {
     NS_LOG_FUNCTION(this);
     // notify all device energy models installed on node
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         (*i)->HandleEnergyRecharged();
     }
@@ -214,8 +207,7 @@
 {
     NS_LOG_FUNCTION(this);
     // notify all device energy models installed on node
-    DeviceEnergyModelContainer::Iterator i;
-    for (i = m_models.Begin(); i != m_models.End(); i++)
+    for (auto i = m_models.Begin(); i != m_models.End(); i++)
     {
         (*i)->HandleEnergyChanged();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/energy/model/generic-battery-model.h ns-3.47/src/energy/model/generic-battery-model.h
--- ns-3.46/src/energy/model/generic-battery-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/energy/model/generic-battery-model.h	2026-02-16 16:08:49.599229800 -0800
@@ -18,6 +18,8 @@
 #include "ns3/nstime.h"
 #include "ns3/traced-value.h"
 
+#include <array>
+
 namespace ns3
 {
 namespace energy
@@ -77,61 +79,73 @@
  *
  *  Contains the values that form the battery presents available in this module.
  */
-static BatteryPresets g_batteryPreset[] = {{NIMH_NICD,
-                                            "Panasonic HHR650D | NiMH | 1.2V 6.5Ah | Size: D",
-                                            1.39,
-                                            7.0,
-                                            1.18,
-                                            6.25,
-                                            1.28,
-                                            1.3,
-                                            0.0046,
-                                            1.3,
-                                            1.0},
-                                           {LEADACID,
-                                            "CSB GP1272 | Lead Acid | 12V 7.2Ah",
-                                            12.8,
-                                            7.2,
-                                            11.5,
-                                            4.5,
-                                            12.5,
-                                            2,
-                                            0.056,
-                                            0.36,
-                                            8.0},
-                                           {LION_LIPO,
-                                            "Panasonic CGR18650DA | Li-Ion | 3.6V 2.45Ah | Size: A",
-                                            4.17,
-                                            2.33,
-                                            3.57,
-                                            2.14,
-                                            3.714,
-                                            1.74,
-                                            0.0830,
-                                            0.466,
-                                            3.0},
-                                           {LEADACID,
-                                            "Rs PRO LGP12100 | Lead Acid | 12V 100Ah",
-                                            12.60,
-                                            130,
-                                            12.44,
-                                            12.3,
-                                            12.52,
-                                            12,
-                                            0.00069,
-                                            5,
-                                            11},
-                                           {NIMH_NICD,
-                                            "PANASONIC N-700AAC | NiCd | 1.2V 700mAh | Size: AA",
-                                            1.38,
-                                            0.790,
-                                            1.17,
-                                            0.60,
-                                            1.25,
-                                            0.24,
-                                            0.016,
-                                            0.7,
-                                            0.8}};
+static const auto g_batteryPreset = std::to_array<BatteryPresets>({
+    {
+        NIMH_NICD,
+        "Panasonic HHR650D | NiMH | 1.2V 6.5Ah | Size: D",
+        1.39,
+        7.0,
+        1.18,
+        6.25,
+        1.28,
+        1.3,
+        0.0046,
+        1.3,
+        1.0,
+    },
+    {
+        LEADACID,
+        "CSB GP1272 | Lead Acid | 12V 7.2Ah",
+        12.8,
+        7.2,
+        11.5,
+        4.5,
+        12.5,
+        2,
+        0.056,
+        0.36,
+        8.0,
+    },
+    {
+        LION_LIPO,
+        "Panasonic CGR18650DA | Li-Ion | 3.6V 2.45Ah | Size: A",
+        4.17,
+        2.33,
+        3.57,
+        2.14,
+        3.714,
+        1.74,
+        0.0830,
+        0.466,
+        3.0,
+    },
+    {
+        LEADACID,
+        "Rs PRO LGP12100 | Lead Acid | 12V 100Ah",
+        12.60,
+        130,
+        12.44,
+        12.3,
+        12.52,
+        12,
+        0.00069,
+        5,
+        11,
+    },
+    {
+        NIMH_NICD,
+        "PANASONIC N-700AAC | NiCd | 1.2V 700mAh | Size: AA",
+        1.38,
+        0.790,
+        1.17,
+        0.60,
+        1.25,
+        0.24,
+        0.016,
+        0.7,
+        0.8,
+    },
+});
 
 /**
  * @ingroup energy
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/fd-net-device/examples/CMakeLists.txt ns-3.47/src/fd-net-device/examples/CMakeLists.txt
--- ns-3.46/src/fd-net-device/examples/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/fd-net-device/examples/CMakeLists.txt	2026-02-16 16:08:49.600230000 -0800
@@ -1,4 +1,7 @@
-include_directories(${DPDK_INCLUDE_DIRS})
+include_directories(
+  SYSTEM
+  ${DPDK_INCLUDE_DIRS}
+)
 
 build_lib_example(
   NAME dummy-network
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/fd-net-device/examples/fd-emu-send.cc ns-3.47/src/fd-net-device/examples/fd-emu-send.cc
--- ns-3.46/src/fd-net-device/examples/fd-emu-send.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/fd-net-device/examples/fd-emu-send.cc	2026-02-16 16:08:49.600230000 -0800
@@ -134,7 +134,7 @@
     std::string emuMode("netmap");
 #endif
 
-    CommandLine cmd;
+    CommandLine cmd(__FILE__);
     cmd.AddValue("deviceName", "Device name", deviceName);
     cmd.AddValue("level", "Enable send (1) or write (0) level test", level);
     cmd.AddValue("emuMode", "Emulation mode in {raw, netmap}", emuMode);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/fd-net-device/examples/fd-emu-tc.cc ns-3.47/src/fd-net-device/examples/fd-emu-tc.cc
--- ns-3.46/src/fd-net-device/examples/fd-emu-tc.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/fd-net-device/examples/fd-emu-tc.cc	2026-02-16 16:08:49.600230000 -0800
@@ -84,7 +84,7 @@
     std::string emuMode("netmap");
 #endif
 
-    CommandLine cmd;
+    CommandLine cmd(__FILE__);
     cmd.AddValue("deviceName0", "Device name", deviceName0);
     cmd.AddValue("deviceName1", "Device name", deviceName1);
     cmd.AddValue("ip0", "Local IP address", ip0);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/flow-monitor/model/flow-monitor.cc ns-3.47/src/flow-monitor/model/flow-monitor.cc
--- ns-3.46/src/flow-monitor/model/flow-monitor.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/flow-monitor/model/flow-monitor.cc	2026-02-16 16:08:49.602229800 -0800
@@ -13,7 +13,6 @@
 #include "ns3/simulator.h"
 
 #include <fstream>
-#include <limits>
 #include <sstream>
 
 #define PERIODIC_CHECK_INTERVAL (Seconds(1))
@@ -541,7 +540,7 @@
         flowStat.jitterSum = Seconds(0);
         flowStat.lastDelay = Seconds(0);
         flowStat.maxDelay = Seconds(0);
-        flowStat.minDelay = Seconds(std::numeric_limits<double>::max());
+        flowStat.minDelay = Time::Max();
         flowStat.txBytes = 0;
         flowStat.rxBytes = 0;
         flowStat.txPackets = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/CMakeLists.txt ns-3.47/src/internet/CMakeLists.txt
--- ns-3.46/src/internet/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/CMakeLists.txt	2026-02-16 16:08:49.605229900 -0800
@@ -3,6 +3,7 @@
     helper/internet-trace-helper.cc
     helper/ipv4-address-helper.cc
     helper/ipv4-global-routing-helper.cc
+    helper/ipv6-global-routing-helper.cc
     helper/ipv4-interface-container.cc
     helper/ipv4-list-routing-helper.cc
     helper/ipv4-routing-helper.cc
@@ -31,7 +32,7 @@
     model/ipv4-address-generator.cc
     model/ipv4-end-point-demux.cc
     model/ipv4-end-point.cc
-    model/ipv4-global-routing.cc
+    model/global-routing.cc
     model/ipv4-header.cc
     model/ipv4-interface-address.cc
     model/ipv4-interface.cc
@@ -133,6 +134,7 @@
     helper/internet-trace-helper.h
     helper/ipv4-address-helper.h
     helper/ipv4-global-routing-helper.h
+    helper/ipv6-global-routing-helper.h
     helper/ipv4-interface-container.h
     helper/ipv4-list-routing-helper.h
     helper/ipv4-routing-helper.h
@@ -161,7 +163,7 @@
     model/ipv4-address-generator.h
     model/ipv4-end-point-demux.h
     model/ipv4-end-point.h
-    model/ipv4-global-routing.h
+    model/global-routing.h
     model/ipv4-header.h
     model/ipv4-interface-address.h
     model/ipv4-interface.h
@@ -267,7 +269,7 @@
     test/ipv4-deduplication-test.cc
     test/ipv4-forwarding-test.cc
     test/ipv4-fragmentation-test.cc
-    test/ipv4-global-routing-test-suite.cc
+    test/global-routing-test-suite.cc
     test/ipv4-header-test.cc
     test/ipv4-list-routing-test-suite.cc
     test/ipv4-packet-info-tag-test-suite.cc
@@ -289,6 +291,7 @@
     test/ipv6-test.cc
     test/neighbor-cache-test.cc
     test/rtt-test.cc
+    test/tcp-abe-test.cc
     test/tcp-advertised-window-test.cc
     test/tcp-bbr-test.cc
     test/tcp-bic-test.cc
@@ -301,6 +304,7 @@
     test/tcp-ecn-test.cc
     test/tcp-endpoint-bug2211.cc
     test/tcp-error-model.cc
+    test/tcp-fack-test.cc
     test/tcp-fast-retr-test.cc
     test/tcp-general-test.cc
     test/tcp-header-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/examples/CMakeLists.txt ns-3.47/src/internet/examples/CMakeLists.txt
--- ns-3.46/src/internet/examples/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/examples/CMakeLists.txt	2026-02-16 16:08:49.608229900 -0800
@@ -25,3 +25,14 @@
     ${libinternet}
     ${libnetwork}
 )
+
+build_lib_example(
+  NAME ipv4-global-routing-print-route
+  SOURCE_FILES ipv4-global-routing-print-route.cc
+  LIBRARIES_TO_LINK
+    ${libapplications}
+    ${libcsma}
+    ${libinternet}
+    ${libnetwork}
+    ${libpoint-to-point}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/examples/ipv4-global-routing-print-route.cc ns-3.47/src/internet/examples/ipv4-global-routing-print-route.cc
--- ns-3.46/src/internet/examples/ipv4-global-routing-print-route.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/internet/examples/ipv4-global-routing-print-route.cc	2026-02-16 16:08:49.608229900 -0800
@@ -0,0 +1,154 @@
+/*
+ * Copyright (c) 2025 Shashwat Patni
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Shashwat Patni <shashwatpatni25@gmail.com>
+ */
+
+#include "ns3/core-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/network-module.h"
+#include "ns3/point-to-point-module.h"
+
+/**
+ * @file This example demonstrates how to use Ipv4GlobalRoutingHelper::PrintRoute()
+ *  and PrintRoutePathAt() and its overloads to print the route path as calculated
+ *  by the global routing protocol. The Print Format loosely follows that of traceroute.
+ *  Similar to traceroute, there is an option to disable the Reverse Node ID lookup.
+ *  We have two functions PrintRoute() and PrintRouteAt(). Each of these has 4 overloads.
+ *  Please refer to the doxygen documentation for more details on each of the functions and its
+ *  overloads.
+ *  The default behaviour is to also print the node id. This can be disabled by setting the
+ *  nodeIdLookup argument to false. This is similar to linux traceroute -n option.
+ *  We explain the use of each of the overloads for PrintRoute() using the below topology
+ *  The PrintRouteAt() variant behaves similarly with the added time argument.
+ *  @verbatim  Simple point to point links:
+      ________
+     /        \
+   n0 -- n1 -- n2 -- n3     n4----n5
+
+   n0 IP: 10.1.1.1, 10.1.4.1
+   n1 IP: 10.1.1.2, 10.1.2.1
+   n2 IP: 10.1.2.2, 10.1.3.1, 10.1.4.2
+   n3 IP: 10.1.3.2
+   n4 IP: 10.1.5.1
+   n5 IP: 10:1:5:2
+
+  Test 1:Route from n1 to 10.1.2.2
+  expected Output:
+  PrintRoute at Time: +0s from Node 1 to address 10.1.2.2, 64 hops Max.
+   1  10.1.2.2 (Node 2)
+
+  Test 2: Route from n1 to n3
+  expected Output:
+  PrintRoute at Time: +0s from Node 1 to Node 3, 64 hops Max.
+   1  10.1.2.2 (Node 2)
+   2  10.1.3.2 (Node 3)
+
+  Test 3: Route from n0 to 10.1.5.2
+  expected Output:
+  PrintRoute at Time: +0s from Node 0 to address 10.1.5.2, 64 hops Max.
+  There is no path from Node 0 to Node 5.
+
+  Test 4: Route from n0 to n3
+  expected Output:
+  PrintRoute at Time: +0s from Node 0 to Node 3, 64 hops Max.
+   1  10.1.4.2 (Node 2)
+   2  10.1.3.2 (Node 3)
+
+  Test 5: Route from n0 to 10.1.2.2
+  expected Output:
+  PrintRoute at Time: +0s from Node 0 to address 10.1.2.2, 64 hops Max.
+   1  10.1.2.2
+
+  Test 6: Route from n0 to n3
+  expected Output:
+  PrintRoute at Time: +0s from Node 0 to Node 3, 64 hops Max.
+   1  10.1.4.2
+   2  10.1.3.2
+
+  Test 7: Route from n1 to 10.1.2.2 at time +2s
+  expected Output:
+  PrintRoute at Time: +2s from Node 1 to address 10.1.2.2, 64 hops Max.
+   1  10.1.2.2 (Node 2)
+
+  Test 8: Route from n1 to n3 at time +4s
+  expected Output:
+  PrintRoute at Time: +4s from Node 1 to Node 3, 64 hops Max.
+   1  10.1.2.2 (Node 2)
+   2  10.1.3.2 (Node 3)
+   @endverbatim
+*/
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("Ipv4GlobalRoutingPrintRoute");
+
+int
+main(int argc, char* argv[])
+{
+    NodeContainer n;
+    n.Create(6);
+    PointToPointHelper pointToPoint;
+    // globalroutinghelper to install global routing on all nodes
+    Ipv4GlobalRoutingHelper globalRouting;
+    InternetStackHelper stack;
+    stack.SetRoutingHelper(globalRouting); // has effect on the next Install ()
+    stack.Install(n);
+
+    // NetDeviceContainers are the return type
+    auto devices01 = pointToPoint.Install(n.Get(0), n.Get(1));
+    auto devices12 = pointToPoint.Install(n.Get(1), n.Get(2));
+    auto devices23 = pointToPoint.Install(n.Get(2), n.Get(3));
+    auto devices02 = pointToPoint.Install(n.Get(0), n.Get(2));
+    auto devices45 = pointToPoint.Install(n.Get(4), n.Get(5));
+
+    // Assign IP Addresses
+    Ipv4AddressHelper address;
+    address.SetBase("10.1.1.0", "255.255.255.0");
+    Ipv4InterfaceContainer interfaces01 = address.Assign(devices01);
+    address.SetBase("10.1.2.0", "255.255.255.0");
+    Ipv4InterfaceContainer interfaces12 = address.Assign(devices12);
+    address.SetBase("10.1.3.0", "255.255.255.0");
+    Ipv4InterfaceContainer interfaces23 = address.Assign(devices23);
+    address.SetBase("10.1.4.0", "255.255.255.0");
+    Ipv4InterfaceContainer interfaces02 = address.Assign(devices02);
+    address.SetBase("10.1.5.0", "255.255.255.0");
+    Ipv4InterfaceContainer interfaces45 = address.Assign(devices45);
+
+    Ipv4GlobalRoutingHelper::PopulateRoutingTables();
+
+    // create an output stream to be used in the examples
+    Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
+
+    //----------------------Now the examples-----------------------
+
+    // PrintRoute(): Route from:  Source node  to destination IP Address given an output stream
+    Ipv4GlobalRoutingHelper::PrintRoute(n.Get(1), interfaces12.GetAddress(1), routingStream);
+
+    // PrintRoute(): Route from : Source node to destination node given an output stream
+    Ipv4GlobalRoutingHelper::PrintRoute(n.Get(1), n.Get(3), routingStream);
+
+    // Variant with output stream as std::cout by default
+    Ipv4GlobalRoutingHelper::PrintRoute(n.Get(0), interfaces45.GetAddress(1));
+
+    Ipv4GlobalRoutingHelper::PrintRoute(n.Get(0), n.Get(3));
+
+    //  PrintRoute() with nodeIdLookup disabled
+    Ipv4GlobalRoutingHelper::PrintRoute(n.Get(0), interfaces12.GetAddress(1), false);
+    // also provide the output stream
+    Ipv4GlobalRoutingHelper::PrintRoute(n.Get(0), n.Get(3), routingStream, false);
+
+    // The At Variants of PrintRoute() behave similarly with the added time argument.
+    Ipv4GlobalRoutingHelper::PrintRouteAt(n.Get(1), interfaces12.GetAddress(1), Seconds(2));
+    Ipv4GlobalRoutingHelper::PrintRouteAt(n.Get(1), n.Get(3), Seconds(4));
+
+    // uncomment to see all routing tables
+    // Ipv4GlobalRoutingHelper::PrintRoutingTableAllAt(Seconds(3),routingStream);
+
+    Simulator::Stop(Seconds(10));
+    Simulator::Run();
+    Simulator::Destroy();
+    return 0;
+}
